diff -ruN vdr-1.3.41/CONTRIBUTORS vdr-1.3.42/CONTRIBUTORS
--- vdr-1.3.41/CONTRIBUTORS	2006-01-29 15:57:13.000000000 +0100
+++ vdr-1.3.42/CONTRIBUTORS	2006-02-05 16:09:51.000000000 +0100
@@ -215,6 +215,7 @@
  path names
  for suggesting that the SVDRP command GRAB should allow file names without extension
  again
+ for reporting a problem with channel up/down switching on single card systems
 
 Ulrich Röder <roeder@efr-net.de>
  for pointing out that there are channels that have a symbol rate higher than 27500
@@ -270,6 +271,7 @@
  for improving the font file generation in the Makefile
  for pointing out a problem with the ERR macro defined by ncurses.h
  for a patch that contained a fix for checking toFile in cCuttingThread::Action()
+ for improving cUnbufferedFile
 
 Werner Fink <werner@suse.de>
  for making I/O more robust by handling EINTR
@@ -548,6 +550,8 @@
  for suggesting to give a message when an instant recording is started
  fpr suggesting to retry a shutdown after a while
  for separating the 'install' target into several individual targets
+ for reporting a problem with scrolling with Up/Down in case there are non-selectable
+ items at the beginning of the menu
 
 Jeremy Hall <jhall@UU.NET>
  for fixing an incomplete initialization of the filter parameters in eit.c
@@ -843,6 +847,8 @@
 Thomas Koch <tom@harhar.net>
  for his support in keeping the Premiere World channels up to date in 'channels.conf'
  for implementing the SVDRP command STAT
+ for reporting a problem with "pending" timers that blocked others that actually
+ could record
 
 Stefan Hußfeldt <vdr@marvin.on-luebeck.de>
  for his help in keeping 'channels.conf.cable' up to date
@@ -880,6 +886,8 @@
  for reporting a problem in case a station defines all 32 audio PIDs
  for suggestions and experiments regarding the buffer reserve in cTransfer
  for reporting a problem with 'summary.vdr' files with more than two empty lines
+ for reporting a problem with multiple entries of the same subdirectory in the
+ "Recordings" menu
 
 Andreas Mair <Andreas.Mair@linogate.com>
  for reporting a short display of the main menu if a plugin displays its own OSD and
@@ -944,6 +952,7 @@
  for a patch that was used to implement automatic cursor advance when entering text
  via the numeric keys
  for reporting a problem with expired timers when shutting down via the Power key
+ for fixing handling the "Blue" key in the "Schedule" menu for the current channel
 
 Ralf Klueber <ralf.klueber@vodafone.com>
  for reporting a bug in cutting a recording if there is only a single editing mark
@@ -1040,6 +1049,7 @@
  DiSEqC data) if the lock is lost
  for fixing handling TS packets in cTS2PES
  for adding a mutex to synchronize cDevice::PlayPesPacket() and SetCurrentAudioTrack()
+ for a suggestion that lead to implementing cDevice::Transferring()
 
 Richard Robson <richard_robson@beeb.net>
  for reporting freezing replay if a timer starts while in Transfer Mode from the
@@ -1061,6 +1071,7 @@
 
 Sebastian Frei <sebastian@schnapsleichen.de>
  for his support in keeping 'channels.conf' up-to-date.
+ for suggesting to rename the Makefile target 'plugins-clean' to 'clean-plugins'
 
 Rene Bartsch <ml@bartschnet.de>
  for reporting a bug in setting the primary device in case none of the devices
@@ -1292,6 +1303,9 @@
  for figuring out some obscure length bytes the the CA PMT Reply data of AlphaCrypt CAMs
  for fixing handling OSD areas that have invalid sizes
  for removing unused variables in skinclassic.c and skinsttng.c
+ for removing leftover 'needsBufferReserve' variable from cTransfer
+ for adding an 'Id' parameter to cDevice::PlayAudio() to allow plugins to easier
+ process the audio data
 
 Jürgen Schmitz <j.schmitz@web.de>
  for reporting a bug in displaying the current channel when switching via the SVDRP
@@ -1330,6 +1344,7 @@
 Arthur Konovalov <kasjas@hot.ee>
  for translating OSD texts to the Estonian language
  for fixing a missing ',' in the Greek OSD texts
+ for fixing a missing ',' in the Swedish OSD texts
 
 Milos Kapoun <m.kapoun@cra.cz>
  for suggesting to skip code table info in SI data
@@ -1351,6 +1366,10 @@
  for making the Makefile report a summary of failed plugins
  for reporting a problem with the new handling of k_Repeat keypresses in channel
  switching
+ for reporting a problem with auto advance in string entry fields when pressing
+ Up/Down in insert mode
+ for fixing handling the "Setup/OSD/Menu button closes" option when set to 'yes' in
+ case a replay is active
 
 Sven Kreiensen <svenk@kammer.uni-hannover.de>
  for his help in keeping 'channels.conf.terr' up to date
@@ -1414,6 +1433,7 @@
  for suggesting to write grabbed images to the SVDRP connection encoded in base64
  for suggesting to open the file handle in the SVDRP GRAB command in a way that
  it won't follow symbolic links, and to canonicalize the file name
+ for making all font and image data 'const'
 
 Sean Carlos <seanc@libero.it>
  for translating OSD texts to the Italian language
@@ -1494,6 +1514,7 @@
  for removing the obsolete "ca.conf" section from vdr.1
  for making the cLircRemote try to reestablish the connection to the LIRC daemon
  in case it breaks
+ for enabling generating a core dump if VDR is run with a different user id
 
 Steffen Beyer <cpunk@reactor.de>
  for fixing setting the colored button help after deleting a recording in case the next
@@ -1590,6 +1611,7 @@
  for fixing handling color buttons in cMenuEditStrItem
  for making the '.update' file in the video directory be touched when a recording is
  added or deleted, so that other VDR instances can update their lists
+ for adding cSkin::GetTextAreaWidth() and cSkin::GetTextAreaFont()
 
 Philip Prindeville <philipp_subx@redfish-solutions.com>
  for updates to 'sources.conf'
@@ -1710,3 +1732,9 @@
 Suur Karu <suurkaru@fastmail.fm>
  for reporting a problem with the tuning timeout for channels that have low symbol
  rates
+
+Ronny Kornexl <ronny.kornexl@online.de>
+ for reporting a problem with setting "No title" for broken event data
+
+Bárta Vladimír <vladimir.barta@k2atmitec.cz>
+ for translating OSD texts to the Czech language
diff -ruN vdr-1.3.41/HISTORY vdr-1.3.42/HISTORY
--- vdr-1.3.41/HISTORY	2006-01-29 15:56:50.000000000 +0100
+++ vdr-1.3.42/HISTORY	2006-02-05 16:09:21.000000000 +0100
@@ -4270,3 +4270,49 @@
   system, it is now tried again after 5 minutes (suggested by Helmut Auer).
 - Separated the 'install' target into several individual targets; renamed the
   'plugins-install' target to 'install-plugins' (thanks to Helmut Auer).
+
+2006-02-05: Version 1.3.42
+
+- Removed leftover 'needsBufferReserve' variable from cTransfer (thanks to Marco
+  Schlüßler).
+- Fixed setting "No title" for broken event data (reported by Ronny Kornexl).
+- Fixed channel up/down switching on single card systems (reported by Stefan
+  Huelswitt).
+- Fixed handling "pending" timers that blocked others that actually could record
+  (reported by Thomas Koch).
+- Speeded up cVideoRepacker (thanks to Reinhard Nissl).
+- Added an 'Id' parameter to cDevice::PlayAudio() to allow plugins to easier
+  process the audio data (thanks to Marco Schlüßler).
+- Added Czech language texts (thanks to Bárta Vladimír).
+  Plugin authors may want to add the new entries to their I18N texts and contact
+  the translators to have their texts translated. Note that there are now 21
+  different OSD languages, so please make sure you have 21 versions for each of
+  your texts.
+- Updated the Polish OSD texts (thanks to Jaroslaw Swierczynski).
+- Fixed auto advance in string entry fields when pressing Up/Down in insert mode
+  (reported by Udo Richter).
+- Fixed handling the "Setup/OSD/Menu button closes" option when set to 'yes' in
+  case a replay is active (thanks to Udo Richter).
+- Improved cUnbufferedFile; USE_FADVISE is now defined in tools.c by default, so
+  if you don't want to use "fadvise" you need to comment out that line (thanks to
+  Artur Skawina).
+- Fixed a missing ',' in the Swedish OSD texts (thanks to Arthur Konovalov).
+- cDevice::Transferring() can now be used to determine whether the (primary)
+  device is currently playing in Transfer Mode (based on a suggestion by
+  Reinhard Nissl).
+- The 'runvdr' script no longer uses the $VDRUSR environment variable to set
+  the user id under which 'vdr' shall run. Just add the '-u username' option
+  when you call 'runvdr'.
+- Fixed multiple entries of the same subdirectory in the "Recordings" menu
+  (reported by Christian Jacobsen).
+- Enabled generating a core dump if VDR is run with a different user id (thanks
+  to Ville Skyttä).
+- Fixed handling the "Blue" key in the "Schedule" menu for the current channel
+  (thanks to Rolf Ahrenberg).
+- Renamed the Makefile target 'plugins-clean' to 'clean-plugins' (suggested by
+  Sebastian Frei).
+- Made all font and image data 'const' (thanks to Darren Salt).
+- Fixed scrolling with Up/Down in case there are non-selectable items at the
+  beginning or end of the menu (reported by Helmut Auer).
+- Added cSkin::GetTextAreaWidth() and cSkin::GetTextAreaFont(), so that a plugin
+  that wants to do special text formatting can do so (thanks to Alexander Rieger).
diff -ruN vdr-1.3.41/INSTALL vdr-1.3.42/INSTALL
--- vdr-1.3.41/INSTALL	2006-01-14 12:27:45.000000000 +0100
+++ vdr-1.3.42/INSTALL	2006-02-04 16:22:39.000000000 +0100
@@ -136,7 +136,8 @@
 causes a program hangup. If you change the command line options for the
 call to the VDR program, be sure to NOT use the '-d' option! Otherwise
 VDR will go into 'deamon' mode and the initial program call will return
-immediately!
+immediately! 'runvdr' needs to be started as user 'root'. Use the '-u'
+option to run the actual 'vdr' program under a different user id.
 
 Setting the system time:
 ------------------------
diff -ruN vdr-1.3.41/Makefile vdr-1.3.42/Makefile
--- vdr-1.3.41/Makefile	2006-01-29 15:50:34.000000000 +0100
+++ vdr-1.3.42/Makefile	2006-02-05 14:37:11.000000000 +0100
@@ -4,7 +4,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Makefile 1.84 2006/01/29 14:50:34 kls Exp $
+# $Id: Makefile 1.85 2006/02/05 13:37:11 kls Exp $
 
 .DELETE_ON_ERROR:
 
@@ -193,7 +193,7 @@
 	    done;\
 	if [ -n "$$failed" ] ; then echo; echo "*** failed plugins:$$failed"; echo; fi
 
-plugins-clean:
+clean-plugins:
 	@for i in `ls $(PLUGINDIR)/src | grep -v '[^a-z0-9]'`; do $(MAKE) -C "$(PLUGINDIR)/src/$$i" clean; done
 	@-rm -f $(PLUGINDIR)/lib/libvdr-*.so.$(VDRVERSION)
 
diff -ruN vdr-1.3.41/PLUGINS/src/hello/i18n.c vdr-1.3.42/PLUGINS/src/hello/i18n.c
--- vdr-1.3.41/PLUGINS/src/hello/i18n.c	2004-01-16 14:28:23.000000000 +0100
+++ vdr-1.3.42/PLUGINS/src/hello/i18n.c	2006-02-04 11:51:41.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: i18n.c 1.4 2004/01/16 13:28:23 kls Exp $
+ * $Id: i18n.c 1.5 2006/02/04 10:51:41 kls Exp $
  */
 
 #include "i18n.h"
@@ -26,6 +26,10 @@
     "",// TODO
     "",// TODO
     "¿àØÒÕâ!",
+    "",// TODO
+    "",// TODO
+    "",// TODO
+    "Ahoj",
   },
   { "Hello world!",
     "Hallo Welt!",
@@ -44,6 +48,10 @@
     "",// TODO
     "",// TODO
     "·ÔàÐÒáâÒãÙ ÜØà!",
+    "",// TODO
+    "",// TODO
+    "",// TODO
+    "Ahoj svìte!",
   },
   { "Howdy folks!",
     "Tach zusammen!",
@@ -62,6 +70,10 @@
     "",// TODO
     "",// TODO
     "ºÐÚ ßÞÖØÒÐÕâÕ?",
+    "",// TODO
+    "",// TODO
+    "",// TODO
+    "Nazdar vespolek!",
   },
   { "A friendly greeting",
     "Ein freundlicher Gruß",
@@ -80,6 +92,10 @@
     "",// TODO
     "",// TODO
     "´àãÖÕáÚÞÕ ßàØÒÕâáâÒØÕ",
+    "",// TODO
+    "",// TODO
+    "",// TODO
+    "Pøátelský pozdrav",
   },
   { "Greeting time (s)",
     "Dauer des Grußes (s)",
@@ -98,6 +114,10 @@
     "",// TODO
     "",// TODO
     "¿àÞÔÞÛÖØâÕÛìÝÞáâì ßàØÒÕâáâÒØï",
+    "",// TODO
+    "",// TODO
+    "",// TODO
+    "Èas pozdravu (s)",
   },
   { "Use alternate greeting",
     "Alternativen Gruß verwenden",
@@ -116,6 +136,10 @@
     "",// TODO
     "",// TODO
     "°ÛìâÕàÝÐâØÒÝÞÕ ßàØÒÕâáâÒØÕ",
+    "",// TODO
+    "",// TODO
+    "",// TODO
+    "Pou¾ít alternativní pozdrav",
   },
   { NULL }
   };
diff -ruN vdr-1.3.41/channels.conf vdr-1.3.42/channels.conf
--- vdr-1.3.41/channels.conf	2006-01-29 16:26:35.000000000 +0100
+++ vdr-1.3.42/channels.conf	2006-02-05 16:12:54.000000000 +0100
@@ -1,3 +1,5 @@
+: first line
+: second line
 RTL Television,RTL;RTL World:12187:hC34:S19.2E:27500:163:104=deu:105:0:12003:1:1089:0
 SAT.1;ProSiebenSat.1:12480:vC34:S19.2E:27500:1791:1792=deu;1795=deu:34:0:46:133:33:0
 ProSieben;ProSiebenSat.1:12480:vC34:S19.2E:27500:255:256=deu;257=deu:32:0:898:133:33:0
@@ -13,10 +15,10 @@
 Phoenix;ARD:11836:hC34:S19.2E:27500:901:902=deu:904:0:28114:1:1101:0
 ZDF;ZDFvision:11953:hC34:S19.2E:27500:110:120=deu,121=2ch;125=dd:130:0:28006:1:1079:0
 3sat;ZDFvision:11953:hC34:S19.2E:27500:210:220=deu,221=2ch;225=dd:230:0:28007:1:1079:0
-KiKa;ZDFvision:11953:hC34:S19.2E:27500:310:320=deu:330:0:28008:1:1079:0
+KiKa;ZDFvision:11953:hC34:S19.2E:27500:310:320:0:0:28008:1:1079:0
 arte;ARD:11836:hC34:S19.2E:27500:401:402=deu,403=fra:404:0:28109:1:1101:0
-ORF1;ORF:12692:hC56:S19.2E:22000:160:161=deu;163=deu:165:1762,D05,1702,1801:13001:1:1117:0
-ORF2;ORF:12692:hC56:S19.2E:22000:500:501=deu;503=deu:505:1762,D05,1702,1801:13002:1:1117:0
+ORF1;ORF:12692:hC56:S19.2E:22000:160:161=deu;163=deu:165:0:13001:1:1117:0
+ORF2;ORF:12692:hC56:S19.2E:22000:500:501=deu,502=deu;503=deu:505:1762,D05,1702,1801:13002:1:1117:0
 ZDFinfokanal;ZDFvision:11953:hC34:S19.2E:27500:610:620=deu:130:0:28011:1:1079:0
 CNN Int.;CNN:11778:vC34:S19.2E:27500:165:100=eng:47:0:28522:1:1068:0
 Super RTL,S RTL;RTL World:12187:hC34:S19.2E:27500:165:120=deu:65:0:12040:1:1089:0
@@ -28,7 +30,7 @@
 HSE24,HSE24;BetaDigital:12480:vC34:S19.2E:27500:1279:1280=deu:37:0:40:133:33:0
 Bloomberg TV Germany;Bloomberg:12551:vC56:S19.2E:22000:162:99=deu:0:0:12160:1:1108:0
 EURONEWS;CSAT:11817:vC34:S19.2E:27500:163:92=fra,93=eng,94=ita,95=esl,91=rus,98=por,99=deu:0:0:8004:1:1070:0
-rbb Brandenburg;ARD:12109:hC34:S19.2E:27500:601:602=deu:604:0:28205:1:1073:0
+rbb Brandenburg;ARD:12109:hC34:S19.2E:27500:501:502=deu:504:0:28205:1:1073:0
 Sky News:11597:vC56:S19.2E:22000:305+131:306=eng:0:0:28707:1:1026:0
 Veronica/JETIX;CANALDIGITAAL:12574:hC56:S19.2E:22000:518+8190:92=dut:38:622,100:5020:53:1109:0
 BVN;CANALDIGITAAL:12574:hC56:S19.2E:22000:515+8190:96=dut:36:0:5025:53:1109:0
@@ -45,14 +47,14 @@
 rbb Berlin;ARD:12109:hC34:S19.2E:27500:601:602=deu:604:0:28206:1:1073:0
 :Premiere World
 PREMIERE START,START;PREMIERE:11797:hC34:S19.2E:27500:255:256=deu:32:1801,1722,1702:8:133:2:0
-PREMIERE 1,PREM 1;PREMIERE:11797:hC34:S19.2E:27500:511:512=deu,513=deu;515=deu:32:1:10:133:2:0
-PREMIERE 2,PREM 2;PREMIERE:11797:hC34:S19.2E:27500:1791:1792=deu,1793=deu;1795=deu:32:1:11:133:2:0
+PREMIERE 1,PREM 1;PREMIERE:11797:hC34:S19.2E:27500:511:512=deu,513=deu;515=deu:32:1801,1722,1702:10:133:2:0
+PREMIERE 2,PREM 2;PREMIERE:11797:hC34:S19.2E:27500:1791:1792=deu,1793=deu;1795=deu:32:1801,1722,1702:11:133:2:0
 PREMIERE 3,PREM 3;PREMIERE:11797:hC34:S19.2E:27500:2303:2304=deu,2305=deu:32:1722,1702,1801:43:133:2:0
-PREMIERE 4,PREM 4;PREMIERE:11797:hC34:S19.2E:27500:767:768=deu,769=deu:32:1:9:133:2:0
+PREMIERE 4,PREM 4;PREMIERE:11797:hC34:S19.2E:27500:767:768=deu,769=deu:32:1801,1722,1702:9:133:2:0
 PREMIERE 5,PREM 5;PREMIERE:11797:hC34:S19.2E:27500:1279:1280=deu:32:1722,1702,1801:29:133:2:0
 PREMIERE 6,PREM 6;PREMIERE:11797:hC34:S19.2E:27500:1535:1536=deu:32:1702,1722,1801:41:133:2:0
 PREMIERE 7,PREM 7;PREMIERE:11797:hC34:S19.2E:27500:1023:1024=deu:32:1801,1702,1722:20:133:2:0
-DISNEY CHANNEL,DISNEY;PREMIERE:11758:hC34:S19.2E:27500:2559:2560=deu:32:1:34:133:17:0
+DISNEY CHANNEL,DISNEY;PREMIERE:11758:hC34:S19.2E:27500:2559:2560=deu:32:1801,1722,1702:34:133:17:0
 :Premiere Direkt
 PREMIERE DIREKT,DIREKT;PREMIERE:12031:hC34:S19.2E:27500:2815:2816=deu,2817=deu;2819=deu:0:0:18:133:4:0
 :PW Erotic
@@ -113,14 +115,14 @@
 Paramount;BSkyB:11526:vC23:S28.2E:27500:2317+2306:2318=eng:2319:960,961:50305:2:2404:0
 ParaComedy 2;BSkyB:11914:hC23:S28.2E:27500:514+8190:642=eng,662=NAR:578:960,961:4504:2:2011:0
 Discovery;BSkyB:11875:hC23:S28.2E:27500:2308:2310=eng,2311=NAR:2309:960,961:6201:2:2009:0
-Sky Movies 1;BSkyB:11836:hC23:S28.2E:27500:518+8190:646=eng,653=NAR;686=eng:582:960,961:4303:2:2007:0
-Sky Movies 2;BSkyB:11836:hC23:S28.2E:27500:519+8190:647=eng,667=NAR;687=eng:583:960,961:4302:2:2007:0
-Sky Movies 3;BSkyB:11836:hC23:S28.2E:27500:520+8190:648=eng,654=NAR;688=eng:584:960,961:4403:2:2007:0
+Sky Movies 1;BSkyB:11836:hC23:S28.2E:27500:518+8190:646=eng,653=NAR;666=eng:582:960,961:4303:2:2007:0
+Sky Movies 2;BSkyB:11836:hC23:S28.2E:27500:519+8190:647=eng,655=NAR;667=eng:583:960,961:4302:2:2007:0
+Sky Movies 3;BSkyB:11836:hC23:S28.2E:27500:520+8190:648=eng,654=NAR;668=eng:584:960,961:4403:2:2007:0
 Sky Movies 4;BSkyB:11914:hC23:S28.2E:27500:512+8190:640=eng,660=NAR:576:960,961:4402:2:2011:0
 Sky Movies 5;BSkyB:11914:hC23:S28.2E:27500:515+8190:643=eng,663=NAR:579:960,961:4503:2:2011:0
 Sky Movies 6;BSkyB:11914:hC23:S28.2E:27500:513+8190:641=eng,661=NAR:577:960,961:4502:2:2011:0
 Sky Movies 7;BSkyB:12285:vC23:S28.2E:27500:515+8190:643=eng,663=NAR:579:960,961:4603:2:2030:0
-Sky Movies 8;BSkyB:11836:hC23:S28.2E:27500:515+8190:643=eng,663=NAR:579:960,961:5502:2:2007:0
+Sky Movies 8;BSkyB:11836:hC23:S28.2E:27500:515+8190:643=eng,656=NAR:579:960,961:5502:2:2007:0
 Sky Movies 9;BSkyB:12285:vC23:S28.2E:27500:518+8190:646=eng,666=NAR:582:960,961:4602:2:2030:0
 Sky Cinema 1;BSkyB:12285:vC23:S28.2E:27500:519+8190:647=eng,667=NAR:583:960,961:4809:2:2030:0
 Sky Cinema 2;BSkyB:12285:vC23:S28.2E:27500:517+8190:645=eng,665=NAR:581:960,961:4802:2:2030:0
diff -ruN vdr-1.3.41/config.h vdr-1.3.42/config.h
--- vdr-1.3.41/config.h	2006-01-27 14:27:41.000000000 +0100
+++ vdr-1.3.42/config.h	2006-01-29 18:24:53.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 1.242 2006/01/27 13:27:41 kls Exp $
+ * $Id: config.h 1.243 2006/01/29 17:24:53 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -19,8 +19,8 @@
 #include "i18n.h"
 #include "tools.h"
 
-#define VDRVERSION  "1.3.41"
-#define VDRVERSNUM   10341  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.3.42"
+#define VDRVERSNUM   10342  // Version * 10000 + Major * 100 + Minor
 
 #define MAXPRIORITY 99
 #define MAXLIFETIME 99
diff -ruN vdr-1.3.41/cutter.c vdr-1.3.42/cutter.c
--- vdr-1.3.41/cutter.c	2006-01-27 14:45:00.000000000 +0100
+++ vdr-1.3.42/cutter.c	2006-02-05 12:06:47.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: cutter.c 1.12 2006/01/27 13:45:00 kls Exp $
+ * $Id: cutter.c 1.14 2006/02/05 11:06:47 kls Exp $
  */
 
 #include "cutter.h"
@@ -66,6 +66,8 @@
      toFile = toFileName->Open();
      if (!fromFile || !toFile)
         return;
+     fromFile->SetReadAhead(MEGABYTE(20));
+     toFile->SetReadAhead(MEGABYTE(20));
      int Index = Mark->position;
      Mark = fromMarks.Next(Mark);
      int FileSize = 0;
@@ -90,6 +92,7 @@
            if (fromIndex->Get(Index++, &FileNumber, &FileOffset, &PictureType, &Length)) {
               if (FileNumber != CurrentFileNumber) {
                  fromFile = fromFileName->SetOffset(FileNumber, FileOffset);
+                 fromFile->SetReadAhead(MEGABYTE(20));
                  CurrentFileNumber = FileNumber;
                  }
               if (fromFile) {
diff -ruN vdr-1.3.41/device.c vdr-1.3.42/device.c
--- vdr-1.3.41/device.c	2006-01-08 12:39:37.000000000 +0100
+++ vdr-1.3.42/device.c	2006-02-04 15:58:24.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 1.121 2006/01/08 11:39:37 kls Exp $
+ * $Id: device.c 1.123 2006/02/04 14:58:24 kls Exp $
  */
 
 #include "device.h"
@@ -924,12 +924,17 @@
   return player != NULL;
 }
 
+bool cDevice::Transferring(void) const
+{
+  return dynamic_cast<cTransfer *>(player) != NULL;
+}
+
 bool cDevice::AttachPlayer(cPlayer *Player)
 {
   if (CanReplay()) {
      if (player)
         Detach(player);
-     if (!dynamic_cast<cTransfer *>(Player))
+     if (!Transferring())
         ClrAvailableTracks();
      pesAssembler->Reset();
      player = Player;
@@ -977,7 +982,7 @@
   return -1;
 }
 
-int cDevice::PlayAudio(const uchar *Data, int Length)
+int cDevice::PlayAudio(const uchar *Data, int Length, uchar Id)
 {
   return -1;
 }
@@ -1000,7 +1005,7 @@
           case 0xC0 ... 0xDF: // audio
                SetAvailableTrack(ttAudio, c - 0xC0, c);
                if (!VideoOnly && c == availableTracks[currentAudioTrack].id) {
-                  w = PlayAudio(Start, d);
+                  w = PlayAudio(Start, d, c);
                   if (FirstLoop)
                      Audios.PlayAudio(Data, Length, c);
                   }
@@ -1026,7 +1031,7 @@
                       if (Setup.UseDolbyDigital) {
                          SetAvailableTrack(ttDolby, SubStreamIndex, SubStreamId);
                          if (!VideoOnly && SubStreamId == availableTracks[currentAudioTrack].id) {
-                            w = PlayAudio(Start, d);
+                            w = PlayAudio(Start, d, SubStreamId);
                             if (FirstLoop)
                                Audios.PlayAudio(Data, Length, SubStreamId);
                             }
@@ -1035,7 +1040,7 @@
                  case 0xA0: // LPCM
                       SetAvailableTrack(ttAudio, SubStreamIndex, SubStreamId);
                       if (!VideoOnly && SubStreamId == availableTracks[currentAudioTrack].id) {
-                         w = PlayAudio(Start, d);
+                         w = PlayAudio(Start, d, SubStreamId);
                          if (FirstLoop)
                             Audios.PlayAudio(Data, Length, SubStreamId);
                          }
diff -ruN vdr-1.3.41/device.h vdr-1.3.42/device.h
--- vdr-1.3.41/device.h	2006-01-08 11:10:26.000000000 +0100
+++ vdr-1.3.42/device.h	2006-02-04 15:22:08.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 1.70 2006/01/08 10:10:26 kls Exp $
+ * $Id: device.h 1.72 2006/02/04 14:22:08 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -424,9 +424,10 @@
        ///< Length) or not at all (returning 0 or -1 and setting 'errno' to EAGAIN).
        ///< \return Returns the number of bytes actually taken from Data, or -1
        ///< in case of an error.
-  virtual int PlayAudio(const uchar *Data, int Length);
+  virtual int PlayAudio(const uchar *Data, int Length, uchar Id);
        ///< Plays the given data block as audio.
        ///< Data points to exactly one complete PES packet of the given Length.
+       ///< Id indicates the type of audio data this packet holds.
        ///< PlayAudio() shall process the packet either as a whole (returning
        ///< Length) or not at all (returning 0 or -1 and setting 'errno' to EAGAIN).
        ///< \return Returns the number of bytes actually taken from Data, or -1
@@ -483,6 +484,8 @@
        ///< guaranteed to always receive complete PES packets.
   bool Replaying(void) const;
        ///< Returns true if we are currently replaying.
+  bool Transferring(void) const;
+       ///< Returns true if we are currently in Transfer Mode.
   void StopReplay(void);
        ///< Stops the current replay session (if any).
   bool AttachPlayer(cPlayer *Player);
diff -ruN vdr-1.3.41/dvbdevice.c vdr-1.3.42/dvbdevice.c
--- vdr-1.3.41/dvbdevice.c	2006-01-28 16:37:01.000000000 +0100
+++ vdr-1.3.42/dvbdevice.c	2006-02-04 11:21:51.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 1.151 2006/01/28 15:37:01 kls Exp $
+ * $Id: dvbdevice.c 1.152 2006/02/04 10:21:51 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -1169,7 +1169,7 @@
   return WriteAllOrNothing(fd_video, Data, Length, 1000, 10);
 }
 
-int cDvbDevice::PlayAudio(const uchar *Data, int Length)
+int cDvbDevice::PlayAudio(const uchar *Data, int Length, uchar Id)
 {
   return WriteAllOrNothing(fd_audio, Data, Length, 1000, 10);
 }
diff -ruN vdr-1.3.41/dvbdevice.h vdr-1.3.42/dvbdevice.h
--- vdr-1.3.41/dvbdevice.h	2005-12-29 14:33:12.000000000 +0100
+++ vdr-1.3.42/dvbdevice.h	2006-02-04 11:21:51.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.h 1.37 2005/12/29 13:33:12 kls Exp $
+ * $Id: dvbdevice.h 1.38 2006/02/04 10:21:51 kls Exp $
  */
 
 #ifndef __DVBDEVICE_H
@@ -119,7 +119,7 @@
   virtual bool CanReplay(void) const;
   virtual bool SetPlayMode(ePlayMode PlayMode);
   virtual int PlayVideo(const uchar *Data, int Length);
-  virtual int PlayAudio(const uchar *Data, int Length);
+  virtual int PlayAudio(const uchar *Data, int Length, uchar Id);
 public:
   virtual int64_t GetSTC(void);
   virtual void TrickSpeed(int Speed);
diff -ruN vdr-1.3.41/epg.c vdr-1.3.42/epg.c
--- vdr-1.3.41/epg.c	2006-01-29 15:17:33.000000000 +0100
+++ vdr-1.3.42/epg.c	2006-02-03 14:16:54.000000000 +0100
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 1.57 2006/01/29 14:17:33 kls Exp $
+ * $Id: epg.c 1.58 2006/02/03 13:16:54 kls Exp $
  */
 
 #include "epg.h"
@@ -321,7 +321,7 @@
                              }
                           }
                        break;
-             case 'e': if (!Event->Title())
+             case 'e': if (Event && !Event->Title())
                           Event->SetTitle(tr("No title"));
                        Event = NULL;
                        break;
diff -ruN vdr-1.3.41/font.c vdr-1.3.42/font.c
--- vdr-1.3.41/font.c	2005-01-14 14:25:35.000000000 +0100
+++ vdr-1.3.42/font.c	2006-02-05 14:49:10.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: font.c 1.11 2005/01/14 13:25:35 kls Exp $
+ * $Id: font.c 1.12 2006/02/05 13:49:10 kls Exp $
  */
 
 #include "config.h"
@@ -35,9 +35,10 @@
 #include "fontfix-iso8859-15.c"
 #include "fontosd-iso8859-15.c"
 #include "fontsml-iso8859-15.c"
+
 // --- cFont -----------------------------------------------------------------
 
-static void *FontData[eDvbCodeSize][eDvbFontSize] = {
+static const void *const FontData[eDvbCodeSize][eDvbFontSize] = {
   { FontOsd_iso8859_1,  FontFix_iso8859_1,  FontSml_iso8859_1 },
   { FontOsd_iso8859_2,  FontFix_iso8859_2,  FontSml_iso8859_2 },
   { FontOsd_iso8859_5,  FontFix_iso8859_5,  FontSml_iso8859_5 },
@@ -58,12 +59,12 @@
 eDvbCode cFont::code = code_iso8859_1;
 cFont *cFont::fonts[eDvbFontSize] = { NULL };
 
-cFont::cFont(void *Data)
+cFont::cFont(const void *Data)
 {
   SetData(Data);
 }
 
-void cFont::SetData(void *Data)
+void cFont::SetData(const void *Data)
 {
   if (Data) {
      height = ((tCharData *)Data)->height;
@@ -112,7 +113,7 @@
      }
 }
 
-void cFont::SetFont(eDvbFont Font, void *Data)
+void cFont::SetFont(eDvbFont Font, const void *Data)
 {
   delete fonts[Font];
   fonts[Font] = new cFont(Data ? Data : FontData[code][Font]);
diff -ruN vdr-1.3.41/font.h vdr-1.3.42/font.h
--- vdr-1.3.41/font.h	2005-03-19 16:51:19.000000000 +0100
+++ vdr-1.3.42/font.h	2006-02-05 14:46:36.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: font.h 1.11 2005/03/19 15:51:19 kls Exp $
+ * $Id: font.h 1.12 2006/02/05 13:46:36 kls Exp $
  */
 
 #ifndef __FONT_H
@@ -43,9 +43,9 @@
   const tCharData *data[NUMCHARS];
   int height;
 public:
-  cFont(void *Data);
+  cFont(const void *Data);
   virtual ~cFont() {}
-  void SetData(void *Data);
+  void SetData(const void *Data);
   virtual int Width(unsigned char c) const { return data[c]->width; }
       ///< Returns the width of the given character.
   virtual int Width(const char *s) const;
@@ -59,7 +59,7 @@
   const tCharData *CharData(unsigned char c) const { return data[c]; }
   static bool SetCode(const char *Code);
   static void SetCode(eDvbCode Code);
-  static void SetFont(eDvbFont Font, void *Data = NULL);
+  static void SetFont(eDvbFont Font, const void *Data = NULL);
   static const cFont *GetFont(eDvbFont Font);
   };
 
diff -ruN vdr-1.3.41/fontfix-iso8859-1.c vdr-1.3.42/fontfix-iso8859-1.c
--- vdr-1.3.41/fontfix-iso8859-1.c	2004-12-18 17:14:47.000000000 +0100
+++ vdr-1.3.42/fontfix-iso8859-1.c	2006-02-05 14:49:39.000000000 +0100
@@ -1,4 +1,4 @@
-cFont::tPixelData FontFix_iso8859_1[][28] = {
+static const cFont::tPixelData FontFix_iso8859_1[][28] = {
   {             // 32
      15, 26,
      0x00000000,  // ...............
diff -ruN vdr-1.3.41/fontfix-iso8859-13.c vdr-1.3.42/fontfix-iso8859-13.c
--- vdr-1.3.41/fontfix-iso8859-13.c	2005-01-14 14:25:35.000000000 +0100
+++ vdr-1.3.42/fontfix-iso8859-13.c	2006-02-05 14:49:42.000000000 +0100
@@ -1,4 +1,4 @@
-cFont::tPixelData FontFix_iso8859_13[][28] = {
+static const cFont::tPixelData FontFix_iso8859_13[][28] = {
   {             // 32
      15, 26,
      0x00000000,  // ...............
diff -ruN vdr-1.3.41/fontfix-iso8859-15.c vdr-1.3.42/fontfix-iso8859-15.c
--- vdr-1.3.41/fontfix-iso8859-15.c	2004-12-18 17:14:48.000000000 +0100
+++ vdr-1.3.42/fontfix-iso8859-15.c	2006-02-05 14:49:43.000000000 +0100
@@ -1,4 +1,4 @@
-cFont::tPixelData FontFix_iso8859_15[][28] = {
+static const cFont::tPixelData FontFix_iso8859_15[][28] = {
   {             // 32
      15, 26,
      0x00000000,  // ...............
diff -ruN vdr-1.3.41/fontfix-iso8859-2.c vdr-1.3.42/fontfix-iso8859-2.c
--- vdr-1.3.41/fontfix-iso8859-2.c	2004-12-18 17:14:48.000000000 +0100
+++ vdr-1.3.42/fontfix-iso8859-2.c	2006-02-05 14:49:43.000000000 +0100
@@ -1,4 +1,4 @@
-cFont::tPixelData FontFix_iso8859_2[][28] = {
+static const cFont::tPixelData FontFix_iso8859_2[][28] = {
   {             // 32
      15, 26,
      0x00000000,  // ...............
diff -ruN vdr-1.3.41/fontfix-iso8859-5.c vdr-1.3.42/fontfix-iso8859-5.c
--- vdr-1.3.41/fontfix-iso8859-5.c	2004-12-18 17:14:48.000000000 +0100
+++ vdr-1.3.42/fontfix-iso8859-5.c	2006-02-05 14:49:44.000000000 +0100
@@ -1,4 +1,4 @@
-cFont::tPixelData FontFix_iso8859_5[][26] = {
+static const cFont::tPixelData FontFix_iso8859_5[][26] = {
   {             // 32
      15, 24,
      0x00000000,  // ...............
diff -ruN vdr-1.3.41/fontfix-iso8859-7.c vdr-1.3.42/fontfix-iso8859-7.c
--- vdr-1.3.41/fontfix-iso8859-7.c	2004-12-18 17:14:49.000000000 +0100
+++ vdr-1.3.42/fontfix-iso8859-7.c	2006-02-05 14:49:45.000000000 +0100
@@ -1,4 +1,4 @@
-cFont::tPixelData FontFix_iso8859_7[][26] = {
+static const cFont::tPixelData FontFix_iso8859_7[][26] = {
   {             // 32
      11, 24,
      0x00000000,  // ...........
diff -ruN vdr-1.3.41/fontosd-iso8859-1.c vdr-1.3.42/fontosd-iso8859-1.c
--- vdr-1.3.41/fontosd-iso8859-1.c	2004-12-18 17:14:49.000000000 +0100
+++ vdr-1.3.42/fontosd-iso8859-1.c	2006-02-05 14:49:46.000000000 +0100
@@ -1,4 +1,4 @@
-cFont::tPixelData FontOsd_iso8859_1[][29] = {
+static const cFont::tPixelData FontOsd_iso8859_1[][29] = {
   {             // 32
      6, 27,
      0x00000000,  // ......
diff -ruN vdr-1.3.41/fontosd-iso8859-13.c vdr-1.3.42/fontosd-iso8859-13.c
--- vdr-1.3.41/fontosd-iso8859-13.c	2005-01-14 14:25:35.000000000 +0100
+++ vdr-1.3.42/fontosd-iso8859-13.c	2006-02-05 14:49:47.000000000 +0100
@@ -1,4 +1,4 @@
-cFont::tPixelData FontOsd_iso8859_13[][29] = {
+static const cFont::tPixelData FontOsd_iso8859_13[][29] = {
   {             // 32
      6, 27,
      0x00000000,  // ......
